c  This code goes over the yearly OMNI files (with short gaps filled by linear interpolation
c    and SYM-H index added) and creates a list of intervals, for which the TS05 model parameters
c     W1-W6 can be calculated
c
          P r o g r a m   Prepare_intervals
C
c   Author:  N. A. Tsyganenko, University of St.Petersburg
c   Date:    09/05/2008, 10/13/2008
c
      implicit real*8 (a-h,o-z)
C
      CHARACTER*80 SWNAME,NAMEOUT
      DIMENSION IDAY(105408),IHOUR(105408),MIN(105408),BXGSM(105408),
     * BYGSM(105408),BZGSM(105408),VGSE(105408),VXGSE(105408),
     * VYGSE(105408),VZGSE(105408),TEMP(105408),DEN(105408),
     * SYMH(105408),IMFFLAG(105408),ISWFLAG(105408)

      SYMH_LOWLIM=-10.D0  !  LOW LIMIT ON SYMH DURING THE 2-HOUR "QUIET-TIME PERIOD"
C                              PRECEDING EACH SELECTED INTERVAL
      DSYMH_LIM=    5.D0  !  UPPER LIMIT ON THE SYMH VARIATION RANGE DURING THE ABOVE QUIET PERIOD
C
c      DO 8 IYEAR=1995,2013
      DO 8 IYEAR=2014,2014

      IF (IYEAR.EQ.1995) THEN
       SWNAME='1995_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='1995_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.1996) THEN
       SWNAME='1996_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='1996_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.1997) THEN
       SWNAME='1997_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='1997_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.1998) THEN
       SWNAME='1998_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='1998_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.1999) THEN
       SWNAME='1999_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='1999_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2000) THEN
       SWNAME='2000_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2000_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2001) THEN
       SWNAME='2001_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2001_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2002) THEN
       SWNAME='2002_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2002_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2003) THEN
       SWNAME='2003_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2003_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2004) THEN
       SWNAME='2004_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2004_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2005) THEN
       SWNAME='2005_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2005_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2006) THEN
       SWNAME='2006_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2006_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2007) THEN
       SWNAME='2007_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2007_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2008) THEN
       SWNAME='2008_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2008_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2009) THEN
       SWNAME='2009_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2009_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2010) THEN
       SWNAME='2010_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2010_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2011) THEN
       SWNAME='2011_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2011_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2012) THEN
       SWNAME='2012_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2012_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2013) THEN
       SWNAME='2013_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2013_Interval_list.txt'
      ENDIF

      IF (IYEAR.EQ.2014) THEN
       SWNAME='2014_IMF_&_SW_gaps_le_3hrs_filled.txt'
       NAMEOUT='2014_Interval_list.txt'
      ENDIF
c
C     READ THE INTERPLANETARY/SYMH DATA SET:
C
      OPEN (UNIT=1,FILE=SWNAME,STATUS='OLD')     !  filename for the solar wind/IMF/Sym-H data
 505  FORMAT(2I4,2I3,F8.2,2F8.2,4F8.1,F7.2,F9.0,F6.0,3X,I2,3X,I2)
C
      NREC=0
C
 1    READ(1,505,END=2) IYEA,IDA,IHOU,MI,BX,BY,BZ,V,VX,VY,VZ,DE,T,SYMHI,
     * IMFLAG,ISFLAG
      NREC=NREC+1
      MINYEAR=(IDA-1)*1440+IHOU*60+MI
      IND=MINYEAR/5+1
      IDAY (IND)=IDA
      IHOUR(IND)=IHOU
      MIN  (IND)=MI
      BXGSM(IND)=BX
      BYGSM(IND)=BY
      BZGSM(IND)=BZ
      VGSE (IND)=V
      VXGSE(IND)=VX
      VYGSE(IND)=VY
      VZGSE(IND)=VZ
C      VTH  (IND)=0.15745*SQRT(T)  !  SQRT(3kT/M_p) in km/s
      TEMP (IND)=T
      DEN  (IND)=DE
      SYMH (IND)=SYMHI
      IMFFLAG(IND)=IMFLAG
      ISWFLAG(IND)=ISFLAG
      GOTO 1

 2    CLOSE(1)

      PRINT *, '  READING OF OMNI DATA FINISHED'
C
C  NOW GO OVER THE CREATED ARRAYS, RECORD-BY-RECORD, AND FIND A SET OF INTERVALS,
C  WHOSE FIRST RECORD IS PRECEDED BY NO LESS THAN 2-HOUR CONTINUOUS QUIET PERIOD,
C  AND ITS LAST RECORD IS IMMEDIATELY FOLLOWED BY A NO-DATA PERIOD (ALL NO-DATA
C  PERIODS HERE ARE LONGER THAN 2 HOURS, SINCE THE SHORTER ONES WERE PREVIOUSLY
C  FILLED IN USING LINEAR INTERPOLATION).
C
C  HERE WE DEFINE THE QUIET PERIOD AS THE ONE, SATISFYING THE FOLLOWING REQUIREMENTS:
C   (i)   NO DATA GAPS (I.E., BOTH IMFFLAG AND ISWFLAG NOT EQUAL -1)
C   (ii)  IMF BZGSM => 0 FOR EACH RECORD IN A ROW
C   (iii) SYM-H => -10 FOR EACH RECORD IN A ROW
C
      OPEN (UNIT=1,FILE=NAMEOUT)
      NUMBER=0  !  TOTAL NUMBER OF RECORDS IN THE SELECTED INTERVALS
      LENGTH_QUIET=0
      IND=0  !  IND IS THE # OF THE CURRENT RECORD; HERE WE INITIALIZE IT WITH 0
C
      SYMHMAX=-1000.
      SYMHMIN=+1000.
C
C  NOW SEARCH FOR THE RECORD THAT CAN BE A CANDIDATE FOR THE FIRST RECORD OF A QUIET-TIME INTERVAL
C
  3   IND=IND+1
       IF (IND.EQ.NREC) GOTO 6
       IF (SYMH(IND).GT.SYMHMAX) SYMHMAX=SYMH(IND)
       IF (SYMH(IND).LT.SYMHMIN) SYMHMIN=SYMH(IND)
C
       IF ((IMFFLAG(IND).EQ.-1).OR.(ISWFLAG(IND).EQ.-1).OR.
     *     (BZGSM(IND).LT.0.D0).OR.(SYMH(IND).LT.SYMH_LOWLIM)) THEN
         LENGTH_QUIET=0
         SYMHMAX=-1000.
         SYMHMIN=+1000.
         GOTO 3  !  THE RECORD DIDN'T MEET THE FIRST 3 REQUIREMENTS (DATA AVAILABLE, IMF_BZ>=0, SYMH>=SY,H_LOWLIM),
C                   SO SKIP IT AND GO TO THE NEXT ONE.
       ENDIF

       IF (LENGTH_QUIET.EQ.0) IND_FIRST_GOOD=IND  !  MARKS THE FIRST RECORD THAT SATISFIED THE FIRST 3 REQUIREMENTS

       IF (SYMHMAX-SYMHMIN.GT.DSYMH_LIM) THEN
        IND=IND_FIRST_GOOD+1
        LENGTH_QUIET=0
        SYMHMAX=-1000.
        SYMHMIN=+1000.
        GOTO 3
       ENDIF
C
       LENGTH_QUIET=LENGTH_QUIET+1    !  FIRST SATISFACTORY RECORD HAS BEEN REACHED
C
       IF (LENGTH_QUIET.EQ.24) THEN   !  LENGTH OF THE CURRENT QUIET INTERVAL REACHED 2 HRS, SO
C                                        LET US GO OVER THE FOLLOWING SEQUENCE OF RECORDS, UNTIL A GAP IS ENCOUNTERED,
C                                        AND WRITE IN THE OUTPUT FILE THE NUMBERS OF ITS FIRST AND LAST RECORDS.
C
       INDBEG=IND   ! INDBEG CORRESPONDS TO THE LAST RECORD OF THE QUIET-TIME PERIOD
C
        DO 5 IND=INDBEG,NREC
          IF ((IMFFLAG(IND).EQ.-1).OR.(ISWFLAG(IND).EQ.-1)) THEN  !  FIRST RECORD OF THE NEXT GAP ENCOUNTERED
            INDEND=IND-1
            INDBEGIN=INDBEG-LENGTH_QUIET+1   !  HERE INDBEGIN CORRESPONDS TO THE BEGINNING OF THE FIRST RECORD
            WRITE (1,100) INDBEGIN,INDEND  !       OF THE 2-HR QUIET INTERVAL
            NUMBER=NUMBER+(INDEND-INDBEGIN+1)
 100        FORMAT((2I10))
            LENGTH_QUIET=0
            SYMHMAX=-1000.
            SYMHMIN=+1000.
            GOTO 3
          ENDIF  !  END OF THE CASE "IMFFLAG(IND).EQ.-1).OR.(ISWFLAG(IND).EQ.-1"
  5     CONTINUE
C
C  THE DO 5 LOOP WAS FULLY EXECUTED, WHICH MEANS THAT WE ARRIVED AT IND=NREC; IN THIS CASE, THE LAST RECORD
C  OF THE YEARLY FILE IS AT THE SAME TIME THE LAST RECORD OF THE LAST GOOD SEQUENCE;
C  LET US INCLUDE IT IN THE OUTPUT FILE AND THEN EXIT:
C
            INDEND=NREC
            INDBEGIN=INDBEG-LENGTH_QUIET+1
            WRITE (1,100) INDBEGIN,INDEND
            NUMBER=NUMBER+(INDEND-INDBEGIN+1)
            GOTO 6
       ENDIF   !    END OF THE CASE "IF (LENGTH_QUIET.EQ.24)"
      GOTO 3

 6    CLOSE(1)

      PRINT *,
     *' TOTAL # OF RECORDS IN ALL SELECTED INTERVALS FOR THIS YEAR:',
     * NUMBER
      PRINT*,'  PERCENTAGE COVERED:', FLOAT(NUMBER)/FLOAT(NREC)*100.,'%'

C
  8   CONTINUE

      PAUSE
C
      END

C**************************************************************************
